package commons;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.tiles.Attribute;
import org.apache.tiles.AttributeContext;
import org.apache.tiles.TilesContainer;
import org.apache.tiles.access.TilesAccess;
import org.springframework.context.MessageSource;
import org.springframework.web.servlet.support.JstlUtils;
import org.springframework.web.servlet.view.AbstractUrlBasedView;


public class TilesView extends AbstractUrlBasedView {

	private MessageSource 	jstlAwareMessageSource;
	
	protected void initApplicationContext() {
		super.initApplicationContext();
		this.jstlAwareMessageSource =
				JstlUtils.getJstlAwareMessageSource(getServletContext(), getApplicationContext());
	}

	protected void renderMergedOutputModel(	
			Map model, 
			HttpServletRequest request, 
			HttpServletResponse response)
			throws Exception {

		TilesContainer container = TilesAccess.getContainer(getServletContext());
		String url = getUrl();
	
		exposeModelAsRequestAttributes(model, request);
		JstlUtils.exposeLocalizationContext(request, this.jstlAwareMessageSource);
		if ( container.isValidDefinition( url, request, response ) ) {
			container.render( url, request, response );
		}
		else {
			AttributeContext ctx = container.getAttributeContext( request, response );
			Attribute content = new Attribute();
			content.setName( "content" );
			content.setType( Attribute.AttributeType.TEMPLATE );
			content.setValue( "/WEB-INF/jsp/" + url + ".jsp" );
			ctx.putAttribute( "content", content );
			container.render( "default-layout", request, response );
		}
	}
}
