package commons.editor;

import java.beans.PropertyEditorSupport;
import java.lang.reflect.Method;

import org.springframework.context.ApplicationContext;

public class EntityEditor extends PropertyEditorSupport
{
  private final static String ID_GETTER_METHOD_NAME = "getId";
  private final static String ENTITY_GETTER_METHOD_NAME = "get";
  
  private Object serviceBean; 
  
  public EntityEditor(ApplicationContext ctx, String serviceBeanName) {
    this.serviceBean = ctx.getBean(serviceBeanName);
  }
  
  @Override
  public String getAsText()
  {
  
	Object entity = getValue();
    
	if (entity == null)
    {
      return "-1";
    }
	else if (entity instanceof Integer)
	{
	   return entity.toString();
	}
    else
    {
      try
      {
        // if (entity.getClass().getAnnotation(Entity.class) == null)
        // {
        // return null;
        // }
   	  
    	Method getId = entity.getClass().getMethod(ID_GETTER_METHOD_NAME);
        int id = (Integer) getId.invoke(entity);
        return String.valueOf(id);
      }
      catch (Exception e)
      {
        e.printStackTrace(System.err);
        return null;
      }
    }
  }

  @Override
  public void setAsText(String textId) throws IllegalArgumentException {
    try {
      int id = Integer.parseInt(textId);
      Method getEntity = serviceBean.getClass().getMethod(ENTITY_GETTER_METHOD_NAME, int.class);
      Object entity = getEntity.invoke(serviceBean, id);
      setValue(entity);
    }
    catch(Exception e)
    {
      e.printStackTrace(System.err);
      setValue(null);
    }
  }
  
}
