package commons.security.authentication.event;

import java.util.HashMap;
import java.util.Map;

public enum AuthenticationEventType
 
{
  Success("Pomyslne zalogowanie"),
  FailureLocked("Konto zablokowane"),
  FailureExpired("Konto wygaslo"),
  FailureDisabled("Konto wylaczone"),
  FailureBadCredentials("Bledna autentykacja");

  private final String                                       opis;

  private final static Map<Integer, AuthenticationEventType> mapaWartosci = new HashMap<Integer, AuthenticationEventType>();

  static
  {
    for (AuthenticationEventType w : AuthenticationEventType.values())
    {
      mapaWartosci.put(w.ordinal(), w);
    }
  }

  private AuthenticationEventType(String opis)
  {
    this.opis = opis;
  }

  public int getWartosc()
  {
    return ordinal();
  }

  public static AuthenticationEventType get(int wartosc)
  {
    return mapaWartosci.get(wartosc);
  }

}
