package commons.security.hibernate.acl;

import java.util.HashMap;
import java.util.Map;

public enum DMLOperationType 
{
  Insert("Insert"), Update("Update"), Delete("Delete");

  private final String                                opis;

  private final static Map<Integer, DMLOperationType> mapaWartosci = new HashMap<Integer, DMLOperationType>();

  static
  {
    for (DMLOperationType w : DMLOperationType.values())
    {
      mapaWartosci.put(w.ordinal(), w);
    }
  }

  private DMLOperationType(String opis)
  {
    this.opis = opis;
  }

  public int getWartosc()
  {
    return ordinal();
  }

  public static DMLOperationType get(int wartosc)
  {
    return mapaWartosci.get(wartosc);
  }

}
