package commons.servlet.ajax;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Iterator;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.web.context.WebApplicationContext;
import org.springframework.web.context.support.WebApplicationContextUtils;

import service.AutorService;
import dao.commons.criteria.BooleanCriterion;
import dao.commons.criteria.Criterion;
import dao.commons.criteria.StringFirstCriterion;
import domain.Autor;

public class ListyServlet extends HttpServlet {

	private static final long serialVersionUID = 8856156552859440519L;

	@Override
	protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

    	WebApplicationContext ctx = WebApplicationContextUtils.getWebApplicationContext(request.getSession().getServletContext());
    	
    	AutorService autorService = (AutorService) ctx.getBean("autorService");
    	    	
		try {
            StringBuilder wynik = new StringBuilder();
            
            String szukanyStart = request.getParameter("q");
            String typ = request.getParameter("pole");
            
            if (szukanyStart != null)
                szukanyStart = szukanyStart.toLowerCase();
            if (szukanyStart == null || (szukanyStart != null && szukanyStart.isEmpty())) return;
            if (typ == null || (typ != null && typ.isEmpty())) return;
            
            ArrayList<Criterion> criteriaList = new ArrayList<Criterion>();
            
            criteriaList.add(new BooleanCriterion("aktywny", "Aktywny",true));
            
             criteriaList.add(new StringFirstCriterion("nazwisko", "Nazwisko",szukanyStart));
                        
             	ArrayList<Autor> list = (ArrayList<Autor>) autorService.findByFirstLetter(criteriaList);
            	Iterator<Autor> listIterator = list.iterator();
            	while (listIterator.hasNext()) 
            		{
            		 Autor autor = listIterator.next();
            		 wynik.append(autor.getNazwisko()+ " " + autor.getImie() + "\n");
            		}
            
            response.setCharacterEncoding("UTF-8");
            
            PrintWriter out = response.getWriter();
                        
            out.print(wynik.toString());
			out.close();

		} catch (IllegalArgumentException e) {
			
		}

	}
}
