package commons.servlet.filter;

import java.io.IOException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.springframework.security.Authentication;
import org.springframework.security.context.SecurityContextHolder;
import org.springframework.security.ui.webapp.AuthenticationProcessingFilter;
import org.springframework.security.userdetails.UserDetails;

public class BibliotekaAuthenticationProcessingFilter extends AuthenticationProcessingFilter
{
  protected final Logger logger = Logger.getLogger(getClass());

  @Override
  protected void onSuccessfulAuthentication(HttpServletRequest request, HttpServletResponse response, Authentication authResult)
      throws IOException
  {
    logger.debug("onSuccessfulAuthentication");

    Object obj = SecurityContextHolder.getContext().getAuthentication().getPrincipal();
    UserDetails userDetails = null;
    if (obj instanceof UserDetails)
    {
      userDetails = (UserDetails) obj;
    }

    super.onSuccessfulAuthentication(request, response, authResult);
  }

}
