package commons.wrapper;

import javax.servlet.jsp.PageContext;

import org.displaytag.decorator.DisplaytagColumnDecorator;
import org.displaytag.exception.DecoratorException;
import org.displaytag.properties.MediaTypeEnum;
import org.springframework.web.context.WebApplicationContext;
import org.springframework.web.context.support.WebApplicationContextUtils;

import service.KsiazkaService;

public class KsiazkaWrapper implements DisplaytagColumnDecorator {

	public Object decorate(Object columnValue, 
			PageContext pageContext, 
            MediaTypeEnum media)
    throws DecoratorException {
		
		Integer id = (Integer)columnValue;
		
		WebApplicationContext ctx = WebApplicationContextUtils.getWebApplicationContext(pageContext. getServletContext());
		KsiazkaService ksiazkaService = ctx.getBean(KsiazkaService.class);
	
		if (ksiazkaService.isDostepna(ksiazkaService.get(id))) 
		{
			return "<a href=\"ksiazkaWypozycz.html?id="+ id + "\">Wypoycz</a>";
		}
		else
		{
			return "";
		}
	}
}
