package controller;

import java.io.IOException;
import java.io.OutputStream;
import java.net.URLEncoder;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.codec.binary.Base64;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.ServletRequestUtils;
import org.springframework.web.bind.annotation.RequestMapping;

import service.KsiazkaService;
import domain.Ksiazka;

@Controller
public class PlikController {

	@Autowired
	KsiazkaService ksiazkaService;
	
	@RequestMapping(value = "/ksiazka/plik.html")
	public void pobierzPlik(HttpServletRequest request, HttpServletResponse response) {
		
		int ksiazkaId = ServletRequestUtils.getIntParameter(request, "ksiazkaId", -1);
		
    	if (ksiazkaId<1) return; 
    	
        Ksiazka ksiazka = (Ksiazka) ksiazkaService.get(ksiazkaId);
        
        if (ksiazka.getPlik() == null || ksiazka.getTypPlik() == null)
        	{
        	 return;
        	}
          
        String userAgent = request.getHeader("User-Agent");

        String encodedFileName = null;

        try {
        
        if (userAgent.contains("MSIE") || userAgent.contains("Opera")) 
        {
                encodedFileName = URLEncoder.encode(ksiazka.getTytul(), "UTF-8");
        }
        else 
        {
                encodedFileName = "=?UTF-8?B?" + new  String(Base64.encodeBase64(ksiazka.getTytul().getBytes("UTF-8")), "UTF-8") + "?=";
        }
           	
			OutputStream o = response.getOutputStream();
			response.setCharacterEncoding("UTF-8");
			response.setContentType(ksiazka.getTypPlik().getOpisResponse());
			response.setHeader("Content-Disposition", "inline; filename="
					+ encodedFileName + "." + ksiazka.getTypPlik().getLabel());
			if (ksiazka.getPlik() != null) {
				o.write(ksiazka.getPlik());
			}
			o.flush();
			o.close();
		} catch (IOException e) {	}
    }
}

