package controller;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.ServletRequestUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

import service.SlownikService;
import domain.commons.Preselection;
import domain.enumType.TypSlownik;

@Controller
public class SlownikListController {

	private final static String FORM_VIEW = "slownik/slownikList";

	@Autowired
	SlownikService slownikService;

	@RequestMapping(method = RequestMethod.GET, value = "/slownik/slownikList.html")
	public String getForm(
			Model model,
			HttpServletRequest request) {
		
		String typ = ServletRequestUtils.getStringParameter(request, "typ" , null);

		Preselection  preselection = new Preselection(TypSlownik.getKlasa(typ));
		preselection.setActive(true);
		
		model.addAttribute("slownikList", slownikService.findByCriteria(preselection));
		model.addAttribute("typ", TypSlownik.getTyp(typ).getLabel());
		return FORM_VIEW;
	}

}
