package dao;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.Hibernate;
import org.hibernate.criterion.MatchMode;
import org.hibernate.criterion.Restrictions;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import dao.commons.GenericDAOImpl;
import domain.Uzytkownik;

@Repository("uzytkownikDAO")
public class UzytkownikDAOImpl extends GenericDAOImpl<Uzytkownik> implements
		UzytkownikDAO {
	
	//na Criteria to sposob toporny
	public List<Uzytkownik> findByNameLike (String imie) {

		//tworzymy obiekt Criteria na rzecz klasy
		Criteria c = sessionFactory.getCurrentSession().createCriteria(Uzytkownik.class);
		//restrykcja dot imienia, dostep TYLKO do pol uzytkownika, ale juz nie do pol adresu
		c.add(Restrictions.ilike("imie", imie, MatchMode.ANYWHERE));
		//return wynik; jest potrzeba po drugiej stronie ArrayList to trzeba zrzutowac sobie
		return c.list();
	}
	
	@Override
	public Uzytkownik getByLogin(String login) {
		
		Criteria c = sessionFactory.getCurrentSession().createCriteria(Uzytkownik.class);
		//restrykcja dot imienia, dostep TYLKO do pol uzytkownika, ale juz nie do pol adresu
		c.add(Restrictions.like("login", login, MatchMode.EXACT));

		
		
		List<Uzytkownik> lista = c.list();

		//if (lista.size() > 1)
		//	throw new DataIntegrityViolationException("Naruszenie unikalnosci.");

		return lista.size() == 0 ? null : lista.get(0);
	}


}
