package dao.commons.criteria;

import java.io.Serializable;

import org.hibernate.Criteria;

public abstract class AbstractCriterion implements Criterion, Serializable
{
  /**
   * 
   */
  private static final long serialVersionUID = 7806559248377730024L;
  
  protected String          path;
  protected String          label;
  protected String          nestedPath;
  protected String          property;
  
  //private boolean         exclusive = true;
  public AbstractCriterion(String path, String label)
  {
    this.setPath(path);
    this.setLabel(label);
  }
  
  @Override
  public String getLabel()
  {
    return label;
  }
  
  @Override
  public void setLabel(String label)
  {
    this.label = label;
  }
  
  @Override
  public String getPath()
  {
    return path;
  }
  
  @Override
  public void setPath(String path)
  {
    this.path = path;
    this.nestedPath = CriteriaHelper.getNestedPath(path);
    this.property = CriteriaHelper.getNestedProperty(path);
  }
  
  @Override
  public String getNestedPath()
  {
    return nestedPath;
  }

  @Override
  public String getProperty()
  {
    return property;
  }

  public abstract void prepareCriteria(Criteria criteria); 
}
