package dao.commons.criteria;

import org.hibernate.Criteria;
import org.hibernate.criterion.Restrictions;

public class BooleanCriterion extends AbstractCriterion
{
  private static final long serialVersionUID = 5747345219889264025L;
  
  private Boolean value;

  public BooleanCriterion(String path, String label, Boolean value)
  {
    super(path, label);
    setValue(value);
  }

  @Override
  public void prepareCriteria(Criteria criteria)
  {
    if (value != null) {
      criteria.add(Restrictions.eq(getProperty(), value));
    }
  }

  public Boolean getValue()
  {
    return value;
  }

  public void setValue(Boolean value)
  {
    this.value = value;
  }

}
