package dao.commons.criteria;

import java.util.Date;

import org.hibernate.Criteria;
import org.hibernate.criterion.Restrictions;

public class DateBetweenCriterion extends AbstractCriterion
{
  private static final long serialVersionUID = -3444631321210597166L;
 
  protected Date dateStart;
  
  protected Date dateEnd;
  
  
  public DateBetweenCriterion(String path, String label,Date dateStart, Date dateEnd)
  {
    super(path, label);
    this.setDateStart(dateStart);
    this.setDateEnd(dateEnd);
  }

  @Override
  public void prepareCriteria(Criteria criteria)
  {
    if (dateStart == null && dateEnd == null) {
      return;
    }
    if (dateStart == null) {
      criteria.add(Restrictions.le(getProperty(), dateEnd));
    }
    else if (dateEnd == null) {
      criteria.add(Restrictions.ge(getProperty(), dateStart));
    }
    else {
      criteria.add(Restrictions.between(getProperty(), dateStart, dateEnd));
    }
  }

  public Date getDateStart()
  {
    return dateStart;
  }

  public void setDateStart(Date dateStart)
  {
    this.dateStart = dateStart;
  }

  public Date getDateEnd()
  {
    return dateEnd;
  }

  public void setDateEnd(Date dateEnd)
  {
    this.dateEnd = dateEnd;
  }
  
}
