package domain;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToOne;
import javax.persistence.SequenceGenerator;

@Entity
public class Adres {
	@Id
	@SequenceGenerator(name = "adres_SEQUENCE", sequenceName = "adres_id_seq")
	@GeneratedValue(generator = "adres_SEQUENCE")
	private int id;

	@ManyToOne
	private Wojewodztwo wojewodztwo;
	
	private String miejscowosc;
	private String ulica;
	private String numerMieszkania;
	private String numerLokalu;
	private String kodPocztowy;
	private boolean aktywny = true;

	public boolean isAktywny() {
		return aktywny;
	}

	public void setAktywny(boolean aktywny) {
		this.aktywny = aktywny;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public Wojewodztwo getWojewodztwo() {
		return wojewodztwo;
	}

	public void setWojewodztwo(Wojewodztwo wojewodztwo) {
		this.wojewodztwo = wojewodztwo;
	}

	public String getMiejscowosc() {
		return miejscowosc;
	}

	public void setMiejscowosc(String miejscowosc) {
		this.miejscowosc = miejscowosc;
	}

	public String getUlica() {
		return ulica;
	}

	public void setUlica(String ulica) {
		this.ulica = ulica;
	}

	public String getNumerMieszkania() {
		return numerMieszkania;
	}

	public void setNumerMieszkania(String numerMieszkania) {
		this.numerMieszkania = numerMieszkania;
	}

	public String getNumerLokalu() {
		return numerLokalu;
	}

	public void setNumerLokalu(String numerLokalu) {
		this.numerLokalu = numerLokalu;
	}

	@OneToOne(mappedBy = "adres")
	private Uzytkownik uzytkownik;

	public Uzytkownik getUzytkownik() {
		return uzytkownik;
	}

	public void setUzytkownik(Uzytkownik uzytkownik) {
		this.uzytkownik = uzytkownik;
	}
	
	public String toString(){
		return (getMiejscowosc()+" "+getUlica()+" "+getNumerMieszkania()+"/"+getNumerMieszkania());
	}

	public String getKodPocztowy() {
		return kodPocztowy;
	}

	public void setKodPocztowy(String kodPocztowy) {
		this.kodPocztowy = kodPocztowy;
	}

	
	
}
