package domain;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Lob;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.SequenceGenerator;
import javax.persistence.Version;

import commons.security.audit.Auditable;
import commons.security.audit.NonAuditableField;

import domain.enumType.TypPlik;

@Entity
@Auditable
public class Ksiazka {
	@Id
	@SequenceGenerator(name = "ksiazka_SEQUENCE", sequenceName = "ksiazka_id_seq")
	@GeneratedValue(generator = "ksiazka_SEQUENCE")
	private int id;
	// private List<Autor> autor;
	private String tytul;
	private String opis;
	private String isbn;
	private String rokWydania;
	private boolean aktywny = true;
	
	@Lob
	@NonAuditableField
	private byte[]       plik;
	
	TypPlik typPlik;
	
	//@Formula ("(select w.datawypozyczenia from Wypozyczenie w where w.ksiazka_id = id and w.datazwrotu is null)")
	//private Date dataOstatniegoWypozyczenia;
	
	
	//public Date getDataOstatniegoWypozyczenia() {
	//	return dataOstatniegoWypozyczenia;
	//}

	//public void setDataOstatniegoWypozyczenia(Date dataOstatniegoWypozyczenia) {
	//	this.dataOstatniegoWypozyczenia = dataOstatniegoWypozyczenia;
	//}

	public List<Wypozyczenie> getListaWypozyczen() {
		return listaWypozyczen;
	}



	public void setListaWypozyczen(List<Wypozyczenie> listaWypozyczen) {
		this.listaWypozyczen = listaWypozyczen;
	}

	@Version
	int optLock;

	public int getOptLock() {
		return optLock;
	}

	public void setOptLock(int optLock) {
		this.optLock = optLock;
	}

	public boolean isAktywny() {
		return aktywny;
	}

	public void setAktywny(boolean aktywny) {
		this.aktywny = aktywny;
	}

	public String getRokWydania() {
		return rokWydania;
	}

	public void setRokWydania(String rokWydania) {
		this.rokWydania = rokWydania;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	/*
	 * public List<Autor> getAutor() { return autor; } public void
	 * setAutor(List<Autor> autor) { this.autor = autor; }
	 */
	public String getTytul() {
		return tytul;
	}

	public void setTytul(String tytul) {
		this.tytul = tytul;
	}

	public String getOpis() {
		return opis;
	}

	public void setOpis(String opis) {
		this.opis = opis;
	}

	public String getIsbn() {
		return isbn;
	}

	public void setIsbn(String isbn) {
		this.isbn = isbn;
	}

	@OneToMany(mappedBy = "ksiazka")
	private List<Wypozyczenie> listaWypozyczen = new ArrayList<Wypozyczenie>();

	public List<Wypozyczenie> getListaWYpozyczen() {
		return listaWypozyczen;
	}

	public void setListaWYpozyczen(List<Wypozyczenie> listaWYpozyczen) {
		this.listaWypozyczen = listaWYpozyczen;
	}

	public Wydawnictwo getWydawnictwo() {
		return wydawnictwo;
	}

	public void setWydawnictwo(Wydawnictwo wydawnictwo) {
		this.wydawnictwo = wydawnictwo;
	}

	public Dzial getDzial() {
		return dzial;
	}

	public void setDzial(Dzial dzial) {
		this.dzial = dzial;
	}

	public List<Autor> getListaAutorow() {
		return listaAutorow;
	}

	public void setListaAutorow(List<Autor> listaAutorow) {
		this.listaAutorow = listaAutorow;
	}

	@ManyToOne
	Wydawnictwo wydawnictwo;

	@ManyToOne
	Dzial dzial;

	@ManyToMany(cascade=CascadeType.ALL)
	@NonAuditableField
	private List<Autor> listaAutorow = new ArrayList<Autor>();

	public byte[] getPlik() {
		return plik;
	}



	public void setPlik(byte[] plik) {
		this.plik = plik;
	}



	public TypPlik getTypPlik() {
		return typPlik;
	}



	public void setTypPlik(TypPlik typPlik) {
		this.typPlik = typPlik;
	}
	
	

}
