package domain;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Version;

import org.hibernate.annotations.Cascade;
import org.hibernate.annotations.Formula;



@Entity
// @Inheritance(strategy=InheritanceType.SINGLE_TABLE)
public class Uzytkownik {

	@Id
	@SequenceGenerator(name = "uzytkownik_SEQUENCE", sequenceName = "uzytkownik_id_seq" )
	@GeneratedValue(generator = "uzytkownik_SEQUENCE" )
	private int id;
	
	private boolean aktywny = true;
	
	private boolean admin = true;
	
	@Formula ("imie||' '||nazwisko")
	String Label;
	
	@Column(nullable = true, length = 64)
	private String haslo;
	
	public String getLabel() {
		return Label;
	}

	public void setLabel(String label) {
		Label = label;
	}

	@Version
	int optLock;

	public int getOptLock() {
		return optLock;
	}

	public void setOptLock(int optLock) {
		this.optLock = optLock;
	}



	public boolean isAktywny() {
		return aktywny;
	}

	public void setAktywny(boolean aktywny) {
		this.aktywny = aktywny;
	}

	@Column(length = 100)
	private String opis;

	@Column(length = 25)
	private String imie;

	@Column(length = 25, nullable = true)
	private String nazwisko;

	private String login;
	
	private String pesel;
	
	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getOpis() {
		return opis;
	}

	public void setOpis(String opis) {
		this.opis = opis;
	}

	public String getImie() {
		return imie;
	}

	public void setImie(String imie) {
		this.imie = imie;
	}

	public String getNazwisko() {
		return nazwisko;
	}

	public void setNazwisko(String nazwisko) {
		this.nazwisko = nazwisko;
	}

	@OneToOne(cascade = CascadeType.ALL)
	@Cascade(org.hibernate.annotations.CascadeType.DELETE_ORPHAN)
	private Adres adres;

	public Adres getAdres() {
		return adres;
	}

	public void setAdres(Adres adres) {
		this.adres = adres;
	}

	@OneToMany(mappedBy = "uzytkownik")
	private List<Wypozyczenie> listaWypozyczen = new ArrayList<Wypozyczenie>();

	public List<Wypozyczenie> getListaWypozyczen() {
		return listaWypozyczen;
	}

	public void setListaWypozyczen(List<Wypozyczenie> listaWypozyczen) {
		this.listaWypozyczen = listaWypozyczen;
	}

	public String getLogin() {
		return login;
	}

	public boolean isAdmin() {
		return admin;
	}

	public void setAdmin(boolean admin) {
		this.admin = admin;
	}

	public String getHaslo() {
		return haslo;
	}

	public void setHaslo(String haslo) {
		this.haslo = haslo;
	}

	public String getPesel() {
		return pesel;
	}

	public void setPesel(String pesel) {
		this.pesel = pesel;
	}

	public void setLogin(String login) {
		this.login = login;
	}


	
}