package domain.commons;

import java.util.ArrayList;
import java.util.List;

import org.displaytag.pagination.PaginatedList;
import org.displaytag.properties.SortOrderEnum;


public class PartialList<T> implements PaginatedList {

	private Preselection preselection;
	private List<T>	list;
	
	public PartialList( Preselection preselection, List list ) {
		this.preselection = preselection;
		this.list = list;
	}
	
	public int getFullListSize() {
		return preselection.getRowCount();
	}

	public List<T> getList() {
		return list;
	}

	public int getObjectsPerPage() {
		return preselection.getPageSize();
	}

	public int getPageNumber() {
		return preselection.getCurrentPage() + 1;
	}

	public String getSearchId() {
		return null;
	}

	public String getSortCriterion() {
		return preselection.getSortProperty();
	}

	public SortOrderEnum getSortDirection() {
		return preselection.isSortAscending() ? 
				SortOrderEnum.ASCENDING : SortOrderEnum.DESCENDING;
	}
	
	
	
}
