package domain.enumType;

import java.util.HashMap;
import java.util.Map;

public enum TypPlik
{
 
  DOC("doc"),
  PDF("pdf"),
  JPG("jpg"),
  XLS("xls");
    
  private final String  label;
  private static Map<String, TypPlik> actionMap;

  static
  {
    actionMap = new HashMap<String,TypPlik>();
    for (TypPlik a : TypPlik.values())
      actionMap.put(a.label, a);
  }

  private TypPlik(String label)
  {
    this.label = label;
  }

  public String getLabel()
  {
    return this.label;
  }

  public static TypPlik get(String label)
  {
    return actionMap.get(label);
  }

  public String getOpisResponse()
  {
  	  if (this == TypPlik.DOC) return "application/msword";
  	  if (this == TypPlik.JPG) return "image/jpg";
  	  if (this == TypPlik.PDF) return "application/pdf";
  	  if (this == TypPlik.XLS) return "application/excel";
  	  
  	  return "";
  }
}




