package domain.enumType;

import java.util.HashMap;
import java.util.Map;

import domain.Dzial;
import domain.Slownik;
import domain.Wojewodztwo;
import domain.Wydawnictwo;

public enum TypSlownik
{
 
  WOJEWODZTWO("wojewodztwo"),
  DZIAL("dzial"),
  WYDAWNICTWO("wydawnictwo");
    
  private final String  label;
  private static Map<String, TypSlownik> actionMap;

  static
  {
    actionMap = new HashMap<String,TypSlownik>();
    for (TypSlownik a : TypSlownik.values())
      actionMap.put(a.label, a);
  }

  private TypSlownik(String label)
  {
    this.label = label;
  }

  public String getLabel()
  {
    return this.label;
  }

  public static TypSlownik get(String label)
  {
    return actionMap.get(label);
  }

  public static TypSlownik getTyp(String nazwa)
  {
  	  if ("dzial".equals(nazwa)) return TypSlownik.DZIAL;
  	  if ("wydawnictwo".equals(nazwa)) return TypSlownik.WYDAWNICTWO;
  	  
  	  return TypSlownik.WOJEWODZTWO;
  }
  
  public static TypSlownik getTyp(Slownik slownik)
  {
  	  if (slownik instanceof Dzial) return TypSlownik.DZIAL;
  	  if (slownik instanceof Wydawnictwo) return TypSlownik.WYDAWNICTWO;
  	  
  	  return TypSlownik.WOJEWODZTWO;
  }
  
  public static Class getKlasa(String nazwa)
  {
  	  if ("dzial".equals(nazwa)) return Dzial.class;
  	  if ("wydawnictwo".equals(nazwa)) return Wydawnictwo.class;
  	  
  	  return Wojewodztwo.class;
  }
  
  public static Slownik getObiekt(String nazwa)
  {
  	  if ("dzial".equals(nazwa)) return new Dzial();
  	  if ("wydawnictwo".equals(nazwa)) return new Wydawnictwo();
  	  
  	  return new Wojewodztwo();
  } 
  
}




