package domain.security;

import java.sql.Timestamp;

import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Lob;
import javax.persistence.SequenceGenerator;

import org.hibernate.annotations.Formula;

import commons.security.hibernate.acl.DMLOperationType;

@Entity
public class AuditRecord
{
  public String getLabelProperty()
  {
    return labelProperty;
  }

  public void setLabelProperty(String labelProperty)
  {
    this.labelProperty = labelProperty;
  }

  @Id
  @SequenceGenerator(name = "AuditRecord_SEQUENCE", sequenceName = "auditRecord_id_seq")
  @GeneratedValue(generator = "AuditRecord_SEQUENCE")
  private int              id;

  private String           login;
  private Timestamp        timeStamp;
  private String           className;
  private String           propertyName;
  private int              objectPK;
  private String           numer;
  @Lob
  private String           newValue;
  @Lob
  private String           oldValue;
  private int              transactionID;
  
  @Formula("className  || ':' ||  propertyName")
  private String                 labelProperty;


  @Enumerated(EnumType.STRING)
  private DMLOperationType dmlOperation;

  public int getId()
  {
    return id;
  }

  public void setId(int id)
  {
    this.id = id;
  }

  public Timestamp getTimeStamp()
  {
    return timeStamp;
  }

  public void setTimeStamp(Timestamp timeStamp)
  {
    this.timeStamp = timeStamp;
  }

  public String getClassName()
  {
    return className;
  }

  public void setClassName(String className)
  {
    this.className = className;
  }

  public int getObjectPK()
  {
    return objectPK;
  }

  public void setObjectPK(int objectPK)
  {
    this.objectPK = objectPK;
  }

  public String getNewValue()
  {
    return newValue;
  }

  public void setNewValue(String newValue)
  {
    this.newValue = newValue;
  }

  public String getOldValue()
  {
    return oldValue;
  }

  public void setOldValue(String oldValue)
  {
    this.oldValue = oldValue;
  }

  public DMLOperationType getDmlOperation()
  {
    return dmlOperation;
  }

  public void setDmlOperation(DMLOperationType dmlOperation)
  {
    this.dmlOperation = dmlOperation;
  }

  public String getPropertyName()
  {
    return propertyName;
  }

  public void setPropertyName(String propertyName)
  {
    this.propertyName = propertyName;
  }

  public int getTransactionID()
  {
    return transactionID;
  }

  public void setTransactionID(int transactionID)
  {
    this.transactionID = transactionID;
  }

  public String getLogin()
  {
    return login;
  }

  public void setLogin(String login)
  {
    this.login = login;
  }

  public String getNumer()
  {
    return numer;
  }

  public void setNumer(String numer)
  {
    this.numer = numer;
  }

  
  
  
}
