package domain.security;

import java.sql.Timestamp;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.SequenceGenerator;

import commons.security.authentication.event.AuthenticationEventType;

@Entity
public class UwierzytelnianieZdarzenie
{

  @Id
  @SequenceGenerator(name = "UwierzytelnianieZdarzenie_SEQUENCE", sequenceName = "uwierzytelnianiezdarzenie_id_seq")
  @GeneratedValue(generator = "UwierzytelnianieZdarzenie_SEQUENCE")
  int                     id;

  @Column(nullable = false)
  @Enumerated(EnumType.STRING)
  AuthenticationEventType typZdarzenia;

  @Column(nullable = false)
  String                  login;

  @Column(nullable = false)
  String                  ip;

  @Column(nullable = false)
  Timestamp               timestamp;

  public int getId()
  {
    return id;
  }

  public void setId(int id)
  {
    this.id = id;
  }

  public AuthenticationEventType getTypZdarzenia()
  {
    return typZdarzenia;
  }

  public void setTypZdarzenia(AuthenticationEventType typZdarzenia)
  {
    this.typZdarzenia = typZdarzenia;
  }

  public String getLogin()
  {
    return login;
  }

  public void setLogin(String login)
  {
    this.login = login;
  }

  public String getIp()
  {
    return ip;
  }

  public void setIp(String ip)
  {
    this.ip = ip;
  }

  public Timestamp getTimestamp()
  {
    return timestamp;
  }

  public void setTimestamp(Timestamp timestamp)
  {
    this.timestamp = timestamp;
  }

}
