package service;

import java.util.List;

import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import dao.KsiazkaDAO;
import domain.Ksiazka;
import domain.commons.Preselection;

@Transactional(propagation = Propagation.REQUIRED)
public interface KsiazkaService {
	public void zapiszKsiazka(Ksiazka ksiazka);

	public void setKsiazkaDAO(KsiazkaDAO KsiazkaDAO);

	public Ksiazka getInitialized(int id);

	public Ksiazka get(int id);

	public void dodajAutora(int idAutor, int idKsiazka);

	public boolean wypozycz(int idKsiazka, int idUzytkownik);
	
	public boolean isDostepna (Ksiazka ksiazka);
	
	public boolean oddaj (int idKsiazka);
	
	List<Ksiazka> loadAll();
	
	List<Ksiazka> findByCriteria(Preselection preselection);
	  
	public List<Ksiazka> findByCriteria(Preselection preselection,boolean ograniczenie);


}