package service;

import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import dao.SlownikDAO;
import domain.Slownik;
import domain.commons.Preselection;

@Service("slownikService")
@Transactional
public class SlownikServiceImpl implements SlownikService {
	
	@Autowired
	private SlownikDAO slownikDAO;

	@Override
	public List<Slownik> findByCriteria(Preselection preselection) {
		
		return slownikDAO.findByCriteria(preselection);
	}

	@Override
	public Slownik get(int id) {

		return slownikDAO.get(id);
	}

	@Override
	public List<Slownik> findByCriteria(Preselection preselection,
			boolean ograniczenie) {
		return slownikDAO.findByCriteria(preselection, ograniczenie);
	}

	@Override
	public List<Slownik> loadAll() {
		return slownikDAO.loadAll();
	}

	@Override
	public void zapiszSlownik(Slownik slownik) {
		
		if (slownik.getId() > 0) 
		{
			slownikDAO.update(slownik);
		} else 
		{
			slownikDAO.save(slownik);
		}
		
	}

	public SlownikDAO getSlownikDAO() {
		return slownikDAO;
	}



	public void setSlownikDAO(SlownikDAO slownikDAO) {
		this.slownikDAO = slownikDAO;
	}


	
	

	protected final Log logger = LogFactory.getLog(getClass());

}
