package service.email.jms;

import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.ObjectMessage;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import service.email.jms.message.KontaktMessage;
import service.email.jms.message.ZwrotMessage;
import service.email.mail.MailService;

//@Service("bibliotekaMessageListener")
@Transactional
public class BibliotekaMessageListener implements MessageListener {
	private final Logger log = Logger.getLogger(getClass());

	@Autowired
	@Qualifier("mailService")
	MailService mailService;

	@Override
	public void onMessage(Message message) {

		if (message instanceof ObjectMessage) {
			try {
				log.error("JMS message received: " + message.getClass().getSimpleName());
				ObjectMessage ob = (ObjectMessage) message;

				if (ob.getObject() instanceof KontaktMessage) {
					mailService.kontakt(((KontaktMessage) ob.getObject()).getLogin());
				} else if (ob.getObject() instanceof ZwrotMessage) {
					mailService.zwrot(((ZwrotMessage) ob.getObject()).getLogin());
				} else {
					log.error("Unknown message type \n" + message + " \n " + ob + "\n");
				}

			} catch (JMSException e) {
				log.error("JMSException ", e);
			}
		}
	}

	public void setMailService(MailService mailService) {
		this.mailService = mailService;
	}

}
