package service.email.jms;

import org.jboss.logging.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.jms.core.JmsTemplate;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import service.email.jms.message.KontaktMessage;
import service.email.jms.message.ZwrotMessage;

@Transactional
//@Service("bibliotekaMessageSender")
public class BibliotekaMessageSenderImpl implements BibliotekaMessageSender {
	private final Logger log = Logger.getLogger(getClass());
	@Autowired
	@Qualifier("jmsTemplate")
	private JmsTemplate jmsTemplate;

	@Override
	public void kontaktMessage(String login) {
		log.error("sending JMS message (new message) to login " + login);
		KontaktMessage km = new KontaktMessage();

		km.setLogin(login);
		jmsTemplate.convertAndSend(km);
	}
	
	@Override
	public void zwrotMessage(String login) {
		log.error("sending JMS message (new message) to login " + login);
		ZwrotMessage zm = new ZwrotMessage();

		zm.setLogin(login);
		jmsTemplate.convertAndSend(zm);
	}

	
	// /////////////////////////////////////////////////////////////////////////
	// getter / setter
	// /////////////////////////////////////////////////////////////////////////
	public JmsTemplate getJmsTemplate() {
		return jmsTemplate;
	}

	public void setJmsTemplate(JmsTemplate jmsTemplate) {
		this.jmsTemplate = jmsTemplate;
	}

}
