package service.security;

import java.io.Serializable;

import org.hibernate.type.Type;

import dao.commons.GenericDAO;
import domain.security.AuditRecord;

public interface AuditLoggerService extends GenericDAO<AuditRecord>
{
  public void logSave(Object entity, Serializable id, Object[] state, String[] propertyNames, Type[] types)
      throws SecurityException;

  void logUpdate(Object entity, Serializable id, Object[] currentState, Object[] previousState, String[] propertyNames,
      Type[] types) throws SecurityException;

  void logDelete(Object entity, Serializable id);

}
