package service.security;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import dao.security.AuditRecordDAO;
import domain.commons.Preselection;
import domain.security.AuditRecord;

@Service
public class AuditRecordServiceImpl implements AuditRecordService {
	
	@Autowired
	private AuditRecordDAO auditRecordDAO;
	
	
	@Override
	public List<AuditRecord> findAll() {
		return auditRecordDAO.findAll();
	}
	
	@Override
	public List findByCriteria(Preselection preselection) {
		return auditRecordDAO.findByCriteria(preselection);
	}
	
	@Override
	public List<AuditRecord> findByCriteria(Preselection preselection,
			boolean ograniczenie) {
		return auditRecordDAO.findByCriteria(preselection, ograniczenie);
	}

	public AuditRecordDAO getAuditRecordDAO() {
		return auditRecordDAO;
	}

	public void setAuditRecordDAO(AuditRecordDAO auditRecordDAO) {
		this.auditRecordDAO = auditRecordDAO;
	}

	@Override
	public void delete(AuditRecord auditRecord) {
		auditRecordDAO.delete(auditRecord);
	}

	@Override
	public AuditRecord get(int id) {
		return  auditRecordDAO.get(id);
	}
}
