package tags;

import java.io.IOException;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.BodyTagSupport;

import org.springframework.util.StringUtils;

public class ButtonTag extends BodyTagSupport
{
  /**
   * 
   */
  private static final long serialVersionUID = 2797465245003310675L;
  private String            name;
  private String            value;
  private String            type;
  private Boolean           disabled;
  private String            cssStyle;
  private String            cssClass;
  private String            onclick;
  private String            confirm;

  public String getConfirm()
  {
    return confirm;
  }

  public void setConfirm(String confirm)
  {
    this.confirm = confirm;
  }

  public String getOnclick()
  {
    return onclick;
  }

  public void setOnclick(String onclick)
  {
    this.onclick = onclick;
  }

  public String getName()
  {
    return name;
  }

  public void setName(String name)
  {
    this.name = name;
  }

  public String getValue()
  {
    return value;
  }

  public void setValue(String value)
  {
    this.value = value;
  }

  public String getType()
  {
    return type;
  }

  public void setType(String type)
  {
    this.type = type;
  }

  public Boolean getDisabled()
  {
    return disabled;
  }

  public void setDisabled(Boolean disabled)
  {
    this.disabled = disabled;
  }

  public String getCssStyle()
  {
    return cssStyle;
  }

  public void setCssStyle(String cssStyle)
  {
    this.cssStyle = cssStyle;
  }

  public String getCssClass()
  {
    return cssClass;
  }

  public void setCssClass(String cssClass)
  {
    this.cssClass = cssClass;
  }

  @Override
  public int doEndTag() throws JspException
  {
    try
    {
      JspWriter out = pageContext.getOut();
      out.print("</button>");
      return EVAL_PAGE;
    }
    catch (IOException e)
    {
      throw new JspException(e);
    }
  }

  @Override
  public int doStartTag() throws JspException
  {
    try
    {
      JspWriter out = pageContext.getOut();
      out.print("<button");
      if (StringUtils.hasText(type))
      {
        out.print(" type=\"");
        out.print(type);
        out.print('"');
      }
      if (StringUtils.hasText(name))
      {
        out.print(" name=\"");
        out.print(name);
        out.print('"');
      }
      if (StringUtils.hasText(value))
      {
        out.print(" value=\"");
        out.print(value);
        out.print('"');
      }
      if (Boolean.TRUE.equals(disabled))
      {
        out.print(" disabled=\"disabled\"");
      }
      if (StringUtils.hasText(cssStyle))
      {
        out.print(" style=\"");
        out.print(cssStyle);
        out.print('"');
      }
      if (StringUtils.hasText(cssClass))
      {
        out.print(" class=\"");
        out.print(cssClass);
        out.print('"');
      }
      if (StringUtils.hasText(confirm))
      {
        out.print(" onclick=\"return confirm('");
        out.print(confirm);
        out.print("');\"");
      }
      else if (StringUtils.hasText(onclick))
      {
        out.print(" onclick=\"");
        out.print(onclick);
        out.print('"');
      }
      out.print(">");
      return EVAL_BODY_INCLUDE;
    }
    catch (IOException e)
    {
      throw new JspException(e);
    }
  }

}
