package validator;


public class PeselValidator {

	private static final String format = "\\d{11}";
	private static byte pesel[];

	public static boolean isValid(String pesel) {
		
		pesel = pesel.trim();
		
		if (!pesel.matches(format)) 
		{
			return false;
		}
			
		return sumaKontrola(pesel);
	}

	private static boolean sumaKontrola(String peselStr) 
	{
		pesel = new byte[11];

		for (int i = 0; i < 11; i++) {
			pesel[i] = Byte.parseByte(peselStr.substring(i, i + 1));
		}
		int sum = 1 * pesel[0] + 3 * pesel[1] + 7 * pesel[2] + 9 * pesel[3] + 1
				* pesel[4] + 3 * pesel[5] + 7 * pesel[6] + 9 * pesel[7] + 1
				* pesel[8] + 3 * pesel[9];
		sum %= 10;
		sum = 10 - sum;
		sum %= 10;

		if (sum == pesel[10]) 
		{
			return true;
		}
		
		return false;
	}

}